lilalo

view l3bashrc @ 157:137cf5a580be

bsd fix
author Igor Chubin <igor@chub.in>
date Mon Nov 28 13:26:46 2011 +0200 (2011-11-28)
parents 40d843395547
children d775ffd49dbf
line source
1 #!/bin/sh
3 # (c) Igor Chubin, igor@chub.in, 2004-2006
5 # Environment variables set by the script:
6 #
7 # L3_SESSION_ID - uniq id of the LiLaLo-session
8 # L3_PARENT_TTY - name of tty on which script is running
9 # PS1 - intercative shell prompt in which LiLaLo hides
10 # various information about the command
11 # L3_TAMPERED_EDITORS - list of editors which are tampered with functions
14 # Functions with the names starting _l3_ are internal.
15 # Such functions are unset before this rc script exits
17 _l3_editors_to_tamper='/bin/vi /usr/bin/vi /usr/bin/vim /bin/ee /usr/bin/ee /usr/bin/pico /usr/bin/nano /usr/local/bin/vim'
19 _l3_start()
20 {
21 echo $- | grep -q i || return 0
22 if _l3_is_running_here
23 then
24 _l3_env
25 _l3_init_prompt
26 l3_fix_prompt
27 _l3_tamper_editors
28 _l3_tamper_commands
29 _l3_unset_internal
30 else
31 _l3_start_session
32 _l3_run_script
33 fi
34 }
36 # ===================== STAGE 1 ============================
38 _l3_is_running_here()
39 {
40 ps waux | awk '{print $2" "$11 }' | grep -q ^$PPID" "script
41 return $?
43 # Check if ^^^^ run on Linux
44 # and del vvvv this if it does
46 export L3_TTY=`/usr/bin/tty`
47 uname -a | grep -qi bsd && bsd=yes
48 proc_on_the_term=`w | grep "${L3_TTY##/dev/}" | awk '{print $8;}'`
49 # freeBSD:
50 [ -n "$bsd" ] && \
51 proc_on_the_term=`w | grep "${L3_TTY##/dev/tty}" | awk '{print $6;}'`
53 [ -n "$proc_on_the_term" ] && echo $proc_on_the_term | grep -q script
54 }
56 _l3_start_session()
57 {
58 export L3_SESSION_ID=${RANDOM}${RANDOM}${RANDOM}${RANDOM}-`date +%s`
59 export L3_HOME=~/.lilalo/
60 mkdir -p $L3_HOME
62 tty=`/usr/bin/tty`
63 uname -a | grep -qi bsd && bsd=yes
64 parent=`cat /proc/$PPID/cmdline 2> /dev/null`
65 [ -z "$parent" ] && parent="`ps waux | awk '{if ($2 == '$PPID') print $11; }'`"
66 system=`uname -rs`
67 login_from=`who | grep "${tty##/dev/}" | awk '{print $6;}' | tr -d '()'`
68 #[ -n "$bsd" ] && login_from="" #FIXME!
69 start_time=`date +%s`
70 hostname=`hostname -f 2> /dev/null`
71 [ -n "$bsd" ] && hostname=`hostname`
73 cat <<INFO > $L3_HOME/$L3_SESSION_ID.info
74 <session>
75 <local_session_id>$L3_SESSION_ID</local_session_id>
76 <hostname>$hostname</hostname>
77 <user>$USER</user>
78 <uid>$UID</uid>
79 <login_from>$login_from</login_from>
80 <tty>$tty</tty>
81 <system>$system</system>
82 <parent>$parent</parent>
83 <ppid>$PPID</ppid>
84 <pid>$$</pid>
85 <start_time>$start_time</start_time>
86 <lang>$LANG</lang>
87 </session>
88 INFO
90 unset parent system login_from start_time hostname tty
91 }
93 _l3_run_script()
94 {
95 uname -a | grep -qi bsd && bsd=yes
96 flush="-f" #linux
97 [ -n "$bsd" ] && flush="-t 0" #freebsd
98 export L3_PARENT_TTY=`/usr/bin/tty`
99 if [ -n "$bsd" ]
100 then
101 exec script $flush -q $L3_HOME/${L3_SESSION_ID}.script ${0#-}
102 else
103 exec script $flush -c ${0#-} -q $L3_HOME/${L3_SESSION_ID}.script
104 fi
105 }
107 # ===================== STAGE 2 ============================
109 _l3_env()
110 {
111 trap l3_close_session 2
112 trap l3_close_session EXIT
113 true
114 }
116 l3_close_session()
117 {
118 (
119 echo '<history>'
120 history | sed 's/&/\&amp;/; s/</\&lt;/g; s/>/\&gt;/g'
121 echo '</history>'
122 ) >> $L3_HOME/$L3_SESSION_ID.info
123 }
125 _l3_init_prompt()
126 {
127 PS1='[\u@\h:\W]\$ '
128 [ $UID = 0 ] \
129 && PS1='\[\033[0;31m\]'$PS1'\[\033[0m\]' \
130 || PS1='\[\033[0;32m\]'$PS1'\[\033[0m\]' \
131 export PS1
132 }
134 l3_fix_prompt()
135 {
136 export PS1='\[$($L3_HOME/l3prompt "v3#\!#$?#$UID#$$#$(/bin/date +%s)#$PWD#$RANDOM#")$(l3_save_last_line >& /dev/null)\]'$PS1
137 }
139 _l3_tamper_editors()
140 {
141 for editor_file in $_l3_editors_to_tamper
142 do
143 [ -x $editor_file ] || continue
144 editor_name=${editor_file##*/}
145 eval "
146 $editor_name() {
147 if [ -d \"\$1\" ]
148 then
149 $editor_file \"\$1\"
150 return \$?
151 else
152 TIME=\"\`date +%s\`\"
153 DIR=\"\"
154 [ \"\${1#/}\" = \"\$1\" ] && DIR=\"\$PWD/\"
155 DIFFNAME=\"\${L3_SESSION_ID}_\${TIME}\`echo \$DIR\$1| sed s@_@__@ | sed 's@/@_@g'\`.diff\"
156 old_file=\"/tmp/l3-saved-\$\$.\$RANDOM.\$RANDOM\"
157 /bin/cp -- \"\$1\" \"\$old_file\" 2> /dev/null
158 $editor_file \"\$@\" || ERR=\$?
159 if [ -e \"\$old_file\" ]
160 then
161 diff -u \"\$old_file\" \"\$1\" > \"\$L3_HOME/\$DIFFNAME\" 2> /dev/null
162 else
163 diff -u /dev/null \"\$1\" > \"\$L3_HOME/\$DIFFNAME\" 2> /dev/null
164 fi
165 /bin/rm \"\$old_file\" 2> /dev/null
166 return \$ERR
167 fi
168 }
169 "
170 L3_TAMPERED_EDITORS="$L3_TAMPERED_EDITORS $editor_name"
171 done
172 [ -n "$L3_TAMPERED_EDITORS" ] && export L3_TAMPERED_EDITORS
173 }
175 _l3_tamper_commands()
176 {
177 tty()
178 {
179 [ -n "$L3_PARENT_TTY" ] && echo $L3_PARENT_TTY || /usr/bin/tty
180 }
181 }
183 _l3_unset_internal()
184 {
185 unset `set | grep '^_l3_.*()' | sed 's/()//'`
186 unset `set | grep '^_l3_.*=' | sed 's/=.*//'`
187 }
189 l3shot()
190 {
191 if [ -x "`which xwd`" ]
192 then
193 _l3_home=${L3_HOME:-~/.lilalo}
194 shot_name="${L3_SESSION_ID}_`date +%s`".xwd
195 echo -n Choose window to be shoot ... >&2
196 [ -d ${_l3_home} ] || mkdir -p ${_l3_home}
197 xwd -out "$_l3_home/$shot_name" \
198 && echo Screenshot is written to ${_l3_home}/${shot_name} \
199 && curl -s -F photo=@$_l3_home/$shot_name http://`l3-config backend_address`/l3-upload
200 else
201 {
202 echo
203 echo "Can't make screenshot :("
204 echo
205 echo I must use program xwd to make screenshot,
206 echo but it seems not to be installed
207 echo Try to find the program in the \"xbase-clients\" package
208 echo
209 } >&2
210 fi
211 }
213 l3upload()
214 {
215 if [ $# -lt 1 ]
216 then
217 echo Usage:
218 echo
219 echo l3upload "<filename> [<time>]"
220 echo
221 echo "<filename>" - name of the file to upload
222 return 1
223 else
224 source=$1
225 time=`date +%s`
226 [ -n "$2" ] && time="$2"
227 target="${L3_SESSION_ID}_$time"_"$(echo $source|sed s@.*/@@)"
228 if echo $source | grep -q http://
229 then
230 curl -s "$source" > /tmp/$target
231 else
232 [ -r "$source" ] || { echo "l3upload: Can't open $source for reading" > /dev/stderr; return 1; }
233 cp $source /tmp/$target
234 fi
235 echo Uploaded file name is ${target}
236 curl -s -F photo=@/tmp/$target http://`l3-config backend_address`/l3-upload && rm -f /tmp/$target
237 fi
238 }
240 l3mass_upload()
241 {
242 for i in "$@"
243 do
244 l3upload $i `perl -e 'print (((stat("$i"))[9])."\n")'`
245 done
246 }
248 # Append lines from "$@" files to the end of the shell history
249 hist_append ()
250 {
251 eval $(cat "$@" | sed 's/"/\\\\"/g' | while read line; do echo history -s \"$line\"\;; done);
252 }
254 l3_save_last_line ()
255 {
256 (
257 echo '<cline>'
258 history 1 | sed 's/&/&amp;/; s/</\&lt;/g; s/>/\&gt;/g'
259 echo '</cline>'
260 ) >> $L3_HOME/$L3_SESSION_ID.info
261 }
263 l3 ()
264 {
265 case "$1" in
266 on)
267 echo switching on
268 ;;
269 off)
270 echo switcing off
271 ;;
272 cd)
273 echo l3cd="$2" > ~/.l3rc
274 ;;
275 pwd)
276 grep ^l3cd= ~/.l3rc | sed s/[^=]*=//
277 ;;
278 *)
279 cat <<EOF
280 l3 [command]:
282 cd new_context - change current lilalo context
283 pwd - show current lilalo context
284 on - switch writing on (NOT IMPLEMENTED YET)
285 off - switch writing off (NOT IMPLEMENTED YET)
287 EOF
288 ;;
289 esac
290 }
292 l3cd()
293 {
294 l3 cd "$@"
295 }
297 l3pwd()
298 {
299 l3 pwd
300 }